/*
** pork_util.h - utility functions
** Copyright (C) 2002-2003 Ryan McCabe <ryan@numb.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
*/

#ifndef __PORK_UTIL_H
#define __PORK_UTIL_H

#ifdef HAVE___ATTRIBUTE__
	#define __notused __attribute__((unused))
#else
	#define __notused
#endif

#define FORMAT_VARIABLE '$'
#define SYMBOL_VARIABLE '$'

#define array_elem(x) (sizeof((x)) / sizeof((x)[0]))

void allcaps(char *s);
char *xstrdup(const char *str);
void *xmalloc(size_t len);
void *xcalloc(size_t nmemb, size_t len);
int xstrncpy(char *dest, const char *src, size_t n);
char *xstrncat(char *dest, const char *src, size_t n);
int blank_str(const char *str);
u_int32_t string_hash(const char *str, u_int32_t order);

inline int str_to_uint(const char *str, u_int32_t *val);
inline int str_to_int(const char *str, int *val);

#endif
